Loading...
Searching...
No Matches
rostlab::blast::parser::basic_symbol< Base > Struct Template Reference

`#include <blast-parser-parser.h>`

Inheritance diagram for rostlab::blast::parser::basic_symbol< Base >:
[legend]
Collaboration diagram for rostlab::blast::parser::basic_symbol< Base >:
[legend]

## Public Types

typedef Base | super_type
| Alias to Base.

## Public Member Functions

| basic_symbol () YY_NOEXCEPT
| Default constructor.
| basic_symbol (const basic_symbol &that)
| Copy constructor.
| basic_symbol (typename Base::kind_type t, YY_MOVE_REF(location_type) l)
| Constructor for valueless symbols.
| basic_symbol (typename Base::kind_type t, YY_RVREF(value_type) v, YY_RVREF(location_type) l)
| Constructor for symbols with semantic value.
| ~basic_symbol ()
| Destroy the symbol.
void | clear () YY_NOEXCEPT
| Destroy contents, and record that is empty.
std::string | name () const YY_NOEXCEPT
| The user-facing name of this symbol.
symbol_kind_type | type_get () const YY_NOEXCEPT
| Backward compatibility (Bison 3.6).
bool | empty () const YY_NOEXCEPT
| Whether empty.
void | move (basic_symbol &s)
| Destructive move, s is emptied into this.

## Public Attributes

value_type | value
| The semantic value.
location_type | location
| The location.

## Detailed Description

template<typename Base>
struct rostlab::blast::parser::basic_symbol< Base >

A complete symbol.

Expects its Base type to provide access to the symbol kind via kind ().

Provide access to semantic value and location.

Definition at line 365 of file blast-parser-parser.h.

## Member Typedef Documentation

## super_type

template<typename Base>

typedef Base rostlab::blast::parser::basic_symbol< Base >::super_type

Alias to Base.

Definition at line 368 of file blast-parser-parser.h.

## Constructor & Destructor Documentation

## basic_symbol() [1/4]

template<typename Base>

rostlab::blast::parser::basic_symbol< Base >::basic_symbol | ( |  | ) |

inline

Default constructor.

Definition at line 371 of file blast-parser-parser.h.

## basic_symbol() [2/4]

template<typename Base>

rostlab::blast::parser::basic_symbol< Base >::basic_symbol | ( | const basic_symbol< Base > & | that | ) |

Copy constructor.

## basic_symbol() [3/4]

template<typename Base>

rostlab::blast::parser::basic_symbol< Base >::basic_symbol | ( | typename Base::kind_type | t,
|  | YY_MOVE_REF(location_type) | l )

Constructor for valueless symbols.

## basic_symbol() [4/4]

template<typename Base>

rostlab::blast::parser::basic_symbol< Base >::basic_symbol | ( | typename Base::kind_type | t,
|  | YY_RVREF(value_type) | v,
|  | YY_RVREF(location_type) | l )

Constructor for symbols with semantic value.

## ~basic_symbol()

template<typename Base>

rostlab::blast::parser::basic_symbol< Base >::~basic_symbol | ( |  | ) |

inline

Destroy the symbol.

Definition at line 397 of file blast-parser-parser.h.

## Member Function Documentation

## clear()

template<typename Base>

void rostlab::blast::parser::basic_symbol< Base >::clear | ( |  | ) |

inline

Destroy contents, and record that is empty.

Definition at line 405 of file blast-parser-parser.h.

## empty()

template<typename Base>

bool rostlab::blast::parser::basic_symbol< Base >::empty | ( |  | ) | const

Whether empty.

## move()

template<typename Base>

void rostlab::blast::parser::basic_symbol< Base >::move | ( | basic_symbol< Base > & | s | ) |

Destructive move, s is emptied into this.

## name()

template<typename Base>

std::string rostlab::blast::parser::basic_symbol< Base >::name | ( |  | ) | const

inline

The user-facing name of this symbol.

Definition at line 411 of file blast-parser-parser.h.

## type_get()

template<typename Base>

symbol_kind_type rostlab::blast::parser::basic_symbol< Base >::type_get | ( |  | ) | const

Backward compatibility (Bison 3.6).

## Member Data Documentation

## location

template<typename Base>

location_type rostlab::blast::parser::basic_symbol< Base >::location

The location.

Definition at line 429 of file blast-parser-parser.h.

## value

template<typename Base>

value_type rostlab::blast::parser::basic_symbol< Base >::value

The semantic value.

Definition at line 426 of file blast-parser-parser.h.

The documentation for this struct was generated from the following file:

- rostlab/blast-parser-parser.h